VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtFiles 
      Height          =   3015
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   4455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Thanks to Patrice Goyer (patrice.goyer@goelis.com)

' If we got the file name through "send to" we only got the short (DOS) name
' This may be troublesome, e.g. if we use the filename to generate
' another filename

' We can use the API function FindFirstFile() to get the full name
' Win32 API
Private Const MAX_PATH As Long = 260

Private Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
        dwFileAttributes As Long
        ftCreationTime As FILETIME
        ftLastAccessTime As FILETIME
        ftLastWriteTime As FILETIME
        nFileSizeHigh As Long
        nFileSizeLow As Long
        dwReserved0 As Long
        dwReserved1 As Long
        cFileName As String * MAX_PATH
        cAlternate As String * 14
End Type

Private Declare Function FindFirstFile Lib "kernel32" _
  Alias "FindFirstFileA" (ByVal lpFileName As String, _
  lpFindFileData As WIN32_FIND_DATA) As Long

Private Declare Function FindClose Lib "kernel32" _
  (ByVal hFindFile As Long) As Long

Private Declare Function GetFullPathName Lib "kernel32" _
  Alias "GetFullPathNameA" (ByVal lpFileName As String, _
  ByVal nBufferLength As Long, ByVal lpBuffer As String, _
  ByVal lpFilePart As String) As Long
Private Sub CompleteFileOpening(FileName As String)
Dim hFind As Long
Dim fileData As WIN32_FIND_DATA
Dim fn As String, fp As String
Dim s As String, sFile, lg As Long

    On Error Resume Next

' First use FindFirstFile() to find the full name
' Pitfall: FindFirstFile() does not return the path name.
' It just returns the base name
' So we first split the file name to recall the file's location

    ExtractFileNameAndPath FileName, fn, fp

    hFind = FindFirstFile(FileName, fileData)

    ' Then we paste back the file name with the path

    If fp = "" Then
        FileName = stripNullChars(fileData.cFileName)
    Else
        FileName = fp & "\" & stripNullChars(fileData.cFileName)
    End If

    ' free the "find" handle
    Call FindClose(hFind)

    ' Finally we use the GetFullPathName() API function to get
    ' the long file name with its path

    ' Note: we make a first call with an empty string and
    ' length=0 in order to get the length of the full name

    s = ""
    lg = 0
    sFile = ""
    lg = GetFullPathName(FileName, lg, s, sFile)

    s = Space(lg) ' get enough memory to contain the file name
    sFile = Space(lg)

    ' now we make the actual call to get the value
    lg = GetFullPathName(FileName, lg, s, sFile)

    ' return with the long path name
    FileName = Left(s, lg)  ' strip off the trailing '\0' of the C string

End Sub

' Split the filename to get basename and file location
' Note: this could also be done using common dialog control smartly
Private Sub ExtractFileNameAndPath(fullName As String, fName As String, fPath As String)
Dim i As Integer, l As Integer, c As String
Dim found As Boolean

    l = Len(fullName)
    If l = 0 Then fName = "": fPath = "": Exit Sub

    found = False
    For i = 1 To l
        c = Mid(fullName, l - i + 1, 1)
        If c = "\" Or c = ":" Then found = True: Exit For
    Next i

    If found Then
        fName = Right(fullName, i - 1)
        fPath = Left(fullName, l - i)
    Else
        fName = fullName
        fPath = ""
    End If
End Sub
' Strip NULL chars at the end of a string
Private Function stripNullChars(ByRef s As String) As String
Dim pos As Long

    pos = 0
    Do While pos < Len(s)
        pos = pos + 1
        If (Asc(Mid(s, pos, 1)) = 0) Then Exit Do
    Loop

    If (pos > 0) And (Asc(Mid(s, pos, 1)) = 0) Then
        stripNullChars = Left(s, pos - 1)
    Else
        stripNullChars = s
    End If
End Function

Private Sub Form_Load()
Dim commands As String
Dim result As String
Dim pos As Integer
Dim file_name As String

    ' Find the space separated parameters.
    commands = Command$
    Do While Len(commands) > 0
        pos = InStr(commands, " ")
        If pos = 0 Then
            file_name = commands
            commands = ""
        Else
            file_name = Trim$(Left$(commands, pos - 1))
            commands = Trim$(Mid$(commands, pos + 1))
        End If

        CompleteFileOpening file_name
        result = result & file_name & vbCrLf
    Loop

    txtFiles.Text = result
End Sub


Private Sub Form_Resize()
    txtFiles.Move 0, 0, ScaleWidth, ScaleHeight
End Sub


